#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <asm/page.h>

#define io_p2v(x) ((x) | 0xa0000000)
#define io_v2p(x) ((x) & ~0xa0000000)

//#include "./2440test/inc/2440addr.h"

#define  ADCCON   0x58000000
#define  ADCDAT0  0x0C
#define  ADCDAT1  0x10

#define  ECFLAG     0x8000
#define  SEL_MUX    0x38	// AIN0..000, AIN1..001, AIN2..010, AIN3..011
#define  STDBM      0x4
#define  READ_START 0x2
#define  ENB_START  0x1

#define ADC_FREQ 2500000

int main( void )
{
	volatile unsigned int	*mmaped;
	int				fd, i;
	unsigned int preScaler = 50000000/ADC_FREQ -1;  //PCLK:50.7MHz
	
	fd = open( "/dev/mem", O_RDWR );
	if ( fd < 0 ) {
		fprintf( stderr, "cannot open /dev/mem\n" );
		return 1;
	}
	mmaped = (volatile unsigned int*)mmap( 0, PAGE_SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, fd, ADCCON );
	close(fd);
	if ( mmaped == MAP_FAILED ) {
		fprintf(stderr,"cannot mmap\n");
		return 1;
	}
//	*mmaped = 0x3FC3;
	printf( "CONT_ADDR=>%X\nCONT=%02x\n", mmaped, *mmaped );
/*
while( 1 )
{
	*mmaped |= ENB_START;
	*mmaped |= READ_START;
//	*mmaped &= ~SEL_MUX;  // AIN0にセット
	*mmaped = (1<<14)|(preScaler<<6)|(0<<3);
	*mmaped &= ~STDBM;

while( *mmaped & 0x1 );
printf( "Opps!\n" );

	while(1)
	{
		if ( *mmaped & ECFLAG ) break;
	}
	printf( "CONT=%02x\nDAT0=%02x    DAT1=%02x\n", mmaped[0], mmaped[ADCDAT0], mmaped[ADCDAT1] );
	
	*mmaped |= STDBM;
	*mmaped &= ~READ_START;

	sleep( 1 );
}
*/
	munmap( (char*)mmaped, PAGE_SIZE );
	return 0;
}
