#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <asm/page.h>

//#include <asm/arch/hardware.h>

#define  _BASE   	0x58000000
#define  __OFFSET   0x010
#define  GPBDAT		0x014

#define  READ_START 0x02
#define  ENB_START  0x01

#define io_p2v(x) (0xf2000000 + ((x) & 0x01ffffff) + (((x) & 0x1c000000) >> 1))
//#define io_p2v(x) ((x) | 0xA0000000)

#define _ADCCON (volatile unsigned int*)(io_p2v(0x58000000))

int main( void )
{
	volatile unsigned int	*mmaped;
	int				fd, i;

	fd = open( "/dev/mem", O_RDWR | O_SYNC );
	if ( fd < 0 ) {
		fprintf( stderr, "cannot open /dev/mem\n" );
		return 1;
	}
	mmaped = (volatile unsigned int*)mmap( 0, 1024, PROT_READ | PROT_WRITE, MAP_SHARED, fd, _BASE );
	close(fd);
	
	if ( mmaped == MAP_FAILED ) {
		fprintf(stderr,"cannot mmap\n");
		return 1;
	}
//	*(mmaped) = 0x3FC7;
	printf( "MEM(CON)=> %04x\n", mmaped );
	printf( " ADCCON-> %04x\n", *mmaped );
	printf( " ADCTSC-> %04x\n", *(mmaped+0x04) );
	printf( " ADCDLY-> %04x\n", *(mmaped+0x08) );
	printf( "\n" );
	
	while(1) if ( *(mmaped) & 0x8000 ) break;
	return 0;
}
